; oGet setup 2.5 by A.Ruzanov
; 21.05.2010


#NoTrayIcon

$MP = "Select a Opera folder in the list below, then click OK."
$MOK = "Setup has finished installing oGet on your computer"
$MTOOBIG = "Error. Menu file too big!"

$MDL_USD = '"Download with USD"'
$MDALL_USD = '"Download All with USD"'
$MDS_USD = '"Download Selection with USD"'

$MDTL = '"Download Text Link with oGet"'
$MDAI = '"Download All Images with oGet"'
$MDAFTP = '"Download All links with FTP"'

$DelMDL = '"Download with oGet"'
$DelMDS = '"Download Selection with oGet"'
$DelMDALL = '"Download All with oGet"'
$DelMSDM = '"Select Download Manager"'
$DelMDTL = '"Download Text Link with oGet"'
$DelMDAI = '"Download All Images with oGet"'
$DelMDAFTP = '"Download All links with FTP"'

Select
	Case @OSLang = 0419
		$MP = "    Opera"
	Case StringInStr("0407,0807,0c07,1007,1407", @OSLang)
		$MP = "Whlen Sie Ihr Opera-Installationsverzeichnis aus und klicken Sie auf OK."
	Case StringInStr("040a,080a,0c0a,100a,140a,180a,1c0a,200a,240a,280a,2c0a,300a,340a,380a,3c0a,400a,440a,480a,4c0a,500a", @OSLang)
		$MP = "Seleccionar la carpeta de Opera de la siguiente lista, despus click OK."
EndSelect


$StartDir = @ScriptDir
If Not FileExists($StartDir & "\opera.exe") Then
	$StartDir = RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last CommandLine v2")
	$StartDir = StringLeft($StartDir, StringInStr($StartDir, "\opera.exe ") - 1)
EndIf
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = RegRead("HKEY_CURRENT_USER\Software\Opera Software", "Last Directory3")
If Not FileExists($StartDir & "\opera.exe") Then $StartDir = ""

$OperaDir = FileSelectFolder($MP, "", 0, $StartDir)
If @error Then Exit

$ver = StringSplit(FileGetVersion($OperaDir & "\Opera.dll"), ".")
$Version = $ver[1] & "." & $ver[2]
$isOpera10 = $ver[1] >= 10

If $isOpera10 Then
	$o6Defini = $OperaDir & "\operaprefs_default.ini"
	$o6ini = "operaprefs.ini"
	$defFolder = $OperaDir & "\ui"
Else
	$o6Defini = $OperaDir & "\OperaDef6.ini"
	$o6ini = "opera6.ini"
	$defFolder = $OperaDir & "\defaults"
EndIf

If StringLeft(IniRead($o6Defini, "System", "Multi User", "1"), 1) = 1 Then
	$MultiUser = true
	$VarOpDir = StringSplit($OperaDir, "\")
	$NameDir = $VarOpDir[UBound($VarOpDir) - 1]
	$OperaProfileDir = @AppDataDir & "\opera\" & $NameDir & "\"
	If Not $isOpera10 Then $OperaProfileDir = $OperaProfileDir & "profile\"
	$DestDir = $OperaProfileDir & "oget\"
Else
	$MultiUser = false
	$OperaProfileDir = $OperaDir & "\profile\"
	$DestDir = $OperaDir & "\oget\"
EndIf

$DestDirUtf = StringToUTF8($DestDir)
$VarMenu = $OperaProfileDir & "menu\"
$VarOpera6 = $OperaProfileDir & $o6ini

$LangPath = IniRead($VarOpera6, "User Prefs", "Language File", "")
$LangName = StringMid($LangPath, StringInStr($LangPath, "\", 0, -1) + 1)
$MenuPath = IniRead($VarOpera6, "User Prefs", "Menu Configuration", "")

Select
	Case $LangName = "english.lng"
		$Language = 0409
	Case $LangName = "ru.lng"
		$Language = 0419
	Case $LangName = "russian.lng"
		$Language = 0419
	Case $LangName = "es-ES.lng"
		$Language = "040a"
	Case $LangName = "es-LA.lng"
		$Language = "080a"
	Case $LangName = "de.lng"
		$Language = 0407
	Case $LangName = "tr.lng"
		$Language = "041f"
	Case $LangName = "zh-CN.lng"
		$Language = 0804
	Case $LangName = "zh-TW.lng"
		$Language = 0404
	Case Else
		$Language = @OSLang
EndSelect

Select
	Case $Language = 0419
		$MOK = "  "
		$MTOOBIG = ".    !"
		$MDL = '"Закачать с oGet"'
		$MDS = '"Закачать выделенное с oGet"'
		$MDALL = '"Закачать всё с oGet"'
		$MSDM = '"Менеджеры закачки"'
		$MDTL = '"Закачать текстовую ссылку с oGet"'
		$MDAI = '"Закачать все картинки с oGet"'
		$MDAFTP = '"Закачать все ссылки с FTP"'
		
	Case StringInStr("0407,0807,0c07,1007,1407", $Language)
		$MOK = "Das Setup hat oGet erfolgreich auf Ihrem Computer installiert"
		$MDL = '"Mit oGet herunterladen"'
		$MDS = '"Auswahl mit oGet herunterladen"'
		$MDALL = '"Alles mit oGet herunterladen"'
		$MSDM = '"Download Manager auswählen"'
		
	Case StringInStr("040a,080a,0c0a,100a,140a,180a,1c0a,200a,240a,280a,2c0a,300a,340a,380a,3c0a,400a,440a,480a,4c0a,500a", $Language)
		$MOK = "Setup ha finalizado de instalar oGet en su computadora"
		$MDL = '"Descargar con oGet"'
		$MDS = '"Descargar selección con oGet"'
		$MDALL = '"Descargar todos los enlaces con oGet"'
		$MSDM = '"Seleccionar Administrador de Descarga"'
		
	Case $Language = 0804
		$MDL = '"用 Oget 下载"'
		$MDS = '"用 oGet 下载文本链接"'
		$MDALL = '"用 oGet 下载所有链接"'
		$MSDM = '"选择下载工具"'
		
	Case $Language = 0404
		$MDL = '"用 Oget 下载"'
		$MDS = '"用 oGet 下载文本链接"'
		$MDALL = '"用 oGet 下载所有链接"'
		$MSDM = '"选择下载工具"'
		
	Case Else
		$MDL = '"Download with oGet"'
		$MDS = '"Download Selection with oGet"'
		$MDALL = '"Download All with oGet"'
		$MSDM = '"Select Download Manager"'
EndSelect

Select
	Case @OSLang = 0419
		$DelMDL = '"Закачать с oGet"'
		$DelMDS = '"Закачать выделенное с oGet"'
		$DelMDALL = '"Закачать всё с oGet"'
		$DelMSDM = '"Менеджеры закачки"'
		$DelMDTL = '"Закачать текстовую ссылку с oGet"'
		$DelMDAI = '"Закачать все картинки с oGet"'
		$DelMDAFTP = '"Закачать все ссылки с FTP"'
		
	Case StringInStr("0407,0807,0c07,1007,1407", @OSLang)
		$DelMDL = '"Mit oGet herunterladen"'
		$DelMDS = '"Auswahl mit oGet herunterladen"'
		$DelMDALL = '"Alles mit oGet herunterladen"'
		$DelMSDM = '"Download Manager auswählen"'
		
	Case StringInStr("040a,080a,0c0a,100a,140a,180a,1c0a,200a,240a,280a,2c0a,300a,340a,380a,3c0a,400a,440a,480a,4c0a,500a", @OSLang)
		$DelMDL = '"Descargar con oGet"'
		$DelMDS = '"Descargar selección con oGet"'
		$DelMDALL = '"Descargar todos los enlaces con oGet"'
		$DelMSDM = '"Seleccionar Administrador de Descarga"'
		
	Case @OSLang = 0804
		$DelMDL = '"用 Oget 下载"'
		$DelMDS = '"用 oGet 下载文本链接"'
		$DelMDALL = '"用 oGet 下载所有链接"'
		$DelMSDM = '"选择下载工具"'
		
	Case @OSLang = 0404
		$DelMDL = '"用 Oget 下载"'
		$DelMDS = '"用 oGet 下载文本链接"'
		$DelMDALL = '"用 oGet 下载所有链接"'
		$DelMSDM = '"选择下载工具"'
EndSelect

DirCreate($DestDir)
FileInstall("FlashGot.exe", $DestDir & "FlashGot.exe", 1)
FileInstall("oGet.exe", $DestDir & "oGet.exe", 1)
FileInstall("oGet_lang.ini", $DestDir & "oGet_lang.ini", 1)


IniWrite($VarOpera6, "File Types Section Info", 'Version', '2')
IniWrite($VarOpera6, "File Types", 'text/ogt', '3,' & $DestDirUtf & 'oGet.exe,,,,|')
IniWrite($VarOpera6, "File Types Extension", 'text/ogt', ',0')

If $MultiUser Then
	IniWrite($DestDir & "oget.ini", "Main", 'OperaDir', $OperaDir)
EndIf

Select
	Case $Language = 0419
		IniWrite($DestDir & "oget.ini", "Main", 'Language', 'ru')
	Case $Language = 0407
		IniWrite($DestDir & "oget.ini", "Main", 'Language', 'de')
	Case $Language = "041f"
		IniWrite($DestDir & "oget.ini", "Main", 'Language', 'tr')
	Case $Language = 0804
		IniWrite($DestDir & "oget.ini", "Main", 'Language', 'zh-cn')
	Case $Language = 0404
		IniWrite($DestDir & "oget.ini", "Main", 'Language', 'zh-tw')
	Case Else
		IniWrite($DestDir & "oget.ini", "Main", 'Language', 'en')
EndSelect

$VarDefMenu = $defFolder & "\standard_menu.ini"

$VarSearchM = FileFindFirstFile($VarMenu & "*.ini")
If $VarSearchM = -1 Or $MenuPath = StringToUTF8($VarDefMenu) Then
	$VarOperaMenu = $VarDefMenu
	Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
Else
	While 1
		$VarOperaMenu = $VarMenu & FileFindNextFile($VarSearchM)
		If @error Then ExitLoop
		Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	WEnd
	FileClose($VarSearchM)
EndIf

MsgBox(64, "oGet2 setup", $MOK, 10)
Run($DestDir & "oget.exe")
Exit

Func StringToUTF8($sString)
	Return BinaryToString(StringToBinary($sString, 4))
EndFunc   ;==>StringToUTF8

Func Transfer($Home)
	$VarBTM = IniReadSection($VarOperaMenu, $Home)
	If @error Then
		$VarHNDL = FileOpen($VarOperaMenu, 1)
		$VarDefHNDL = FileOpen($VarDefMenu, 0)
		$BTM = ""
		While $BTM <> "[" & $Home & "]"
			$BTM = FileReadLine($VarDefHNDL)
		WEnd
		
		$BTM = @CRLF & $BTM
		
		Do
			FileWriteLine($VarHNDL, $BTM)
			$BTM = FileReadLine($VarDefHNDL)
		Until StringLeft($BTM, 1) = "[" Or StringLeft($BTM, 2) = ";["
		FileClose($VarHNDL)
		FileClose($VarDefHNDL)
	EndIf
EndFunc   ;==>Transfer

Func Correct($VarOperaMenu, $VarDefMenu, $OperaDir)
	If FileGetSize($VarOperaMenu) > 64000 And @OSType = "WIN32_WINDOWS" Then
		MsgBox(64, "oGet2 setup", $MTOOBIG, 10)
		Exit
	EndIf

	$VarBak = $VarOperaMenu & "_1.bak"
	If FileExists($VarBak) Then
		$Num = 2
		While FileExists($VarOperaMenu & "_" & $Num & ".bak")
			$Num = $Num + 1
		WEnd
		$VarBak = $VarOperaMenu & "_" & $Num & ".bak"
	EndIf
	
	FileCopy($VarOperaMenu, $VarBak, 1)
	
	Transfer("Link Popup Menu")
	Transfer("Image Link Popup Menu")
	Transfer("Hotclick Popup Menu")
	Transfer("Document Popup Menu")
	Transfer("Browser Tools Menu")
	Transfer("Links Panel Item Menu")
	
	IniDelete($VarOperaMenu, "Link Popup Menu", 'Platform Windows, Item, "Download with oGet"')
	IniDelete($VarOperaMenu, "Image Link Popup Menu", 'Platform Windows, Item, "Download with oGet"')
	IniDelete($VarOperaMenu, "Links Panel Item Menu", 'Platform Windows, Item, "Download with oGet"')
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Download Selection with oGet"')
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Download Text Link with oGet"')
	IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, "Download All with oGet"')
	IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, "Download All links with FTP"')
	IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, "Download All Images with oGet"')
	IniDelete($VarOperaMenu, "Browser Tools Menu", 'Platform Windows, Item, "Select Download Manager"')
	
	IniDelete($VarOperaMenu, "Link Popup Menu", 'Platform Windows, Item, ' & $DelMDL)
	IniDelete($VarOperaMenu, "Image Link Popup Menu", 'Platform Windows, Item, ' & $DelMDL)
	IniDelete($VarOperaMenu, "Links Panel Item Menu", 'Platform Windows, Item, ' & $DelMDL)
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, ' & $DelMDS)
	IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, ' & $DelMDTL)
	IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $DelMDALL)
	IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $DelMDAFTP)
	IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $DelMDAI)
	IniDelete($VarOperaMenu, "Browser Tools Menu", 'Platform Windows, Item, ' & $DelMSDM)
	
	IniDelete($VarOperaMenu, "Browser Tools Menu", 'Platform Windows, Submenu, "Select Download Manager", Downloaders Menu')
	IniDelete($VarOperaMenu, "Browser Tools Menu", 'Platform Windows, Submenu, ' & $MSDM & ', Downloaders Menu')
	IniDelete($VarOperaMenu, "Links Panel Item Menu", 'Platform Windows, Item, ' & $MDALL)
	IniDelete($VarOperaMenu, "Links Panel Item Menu", 'Platform Windows, Item, ' & $MDAI)

	If $Version >= 10.5 Then
		Transfer("Prefs O Menu")
		IniWrite($VarOperaMenu, "Prefs O Menu", 'Platform Windows, Item, ' & $MSDM, 'Execute program, "' & $DestDirUtf & 'oget.exe",,, "Save"')
	EndIf
	IniWrite($VarOperaMenu, "Browser Tools Menu", 'Platform Windows, Item, ' & $MSDM, 'Execute program, "' & $DestDirUtf & 'oget.exe",,, "Save"')

	IniWrite($VarOperaMenu, "Links Panel Item Menu", '--------------------', '')
	
	If $Version < 9.5 Or $Version > 9.6 Then
		$JsDownLink = '"Execute program, "' & $DestDirUtf & 'oget.exe", "%l %u %T",,"Save" "'
	Else
		$JsDownLink = '"Execute program, "' & $DestDirUtf & 'oget.exe", "%L %U %T",,"Save" "'
	EndIf
	If $Version > 10.5 Then
		$JsDownLink = '"Go to Page, "javascript:void(inivar=''%l'')" & Go to Page, "javascript:(function(){var encodeBase64=function(a){var b,c,d,e='''',f=[],i=0,j=0,g=0,h=''ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=''.split('''');while(g=a.charCodeAt(j++)){if(g<128){f[f.length]=g}else if(g<2048){f[f.length]=192|(g>>6);f[f.length]=128|(g&63)}else if(g<65536){f[f.length]=224|(g>>12);f[f.length]=128|((g>>6)&63);f[f.length]=128|(g&63)}else{f[f.length]=240|(g>>18);f[f.length]=128|((g>>12)&63);f[f.length]=128|((g>>6)&63);f[f.length]=128|(g&63)}};while(i<f.length){b=f[i++];c=f[i++];d=f[i++];e+=h[b>>2];e+=h[((b&3)<<4)|(c>>4)];e+=h[c===undefined?64:((c&15)<<2)|(d>>6)];e+=h[d===undefined?64:d&63]};return e};var getTLD=function(domain){if(!domain)return;if(/^(?:\d{1,3}\.){3}\d{1,3}$/.test(domain))return domain;var a=domain.split(''.'');var l=a.length;return(l<3)?domain:(a[l-2]+''.''+a[l-1])};var hostName=function(link){var a=document.createElement(''a'');a.href=link;return(a.host.length<a.hostname.length)?a.host:a.hostname};var rn=''\r\n'',ele=document.activeElement;var link=ele&&ele.href;var txt=document.getSelection().toString()||(link?ele.innerText:'''');if(!link)link=window.inivar;window.inivar=null;if(txt)txt=txt.replace(/\s/g,'' '').replace(/^\s+|\s+$/g,'''').replace(/\x22/g,''\x27'');var cookie=(document.cookie&&getTLD(location.hostname)==getTLD(hostName(link)))?document.cookie+''; '':'''';var src=''data:text/ogt;charset=UTF-8;base64,''+encodeBase64(''1;My_Download_Manager;0;;''+rn+location.href+rn+link+rn+txt+rn+cookie+rn+rn+rn);if(top==self){var f=document.createElement(''iframe'');f.width=0;f.height=0;f.frameBorder=''no'';f.scrolling=''no'';f.src=src;document.documentElement.appendChild(f);setTimeout(function(){f.parentNode.removeChild(f)},1)}else{location.href=src}})()" "'
	EndIf

	$JsDownSel = '"Go to Page,"javascript:void(inivar=''%t'')",,,"Save" & Go to Page, "javascript:(function(){var encodeBase64=function(a){var b,c,d,e='''',f=[],i=0,j=0,g=0,h=''ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=''.split('''');while(g=a.charCodeAt(j++)){if(g<128){f[f.length]=g}else if(g<2048){f[f.length]=192|(g>>6);f[f.length]=128|(g&63)}else if(g<65536){f[f.length]=224|(g>>12);f[f.length]=128|((g>>6)&63);f[f.length]=128|(g&63)}else{f[f.length]=240|(g>>18);f[f.length]=128|((g>>12)&63);f[f.length]=128|((g>>6)&63);f[f.length]=128|(g&63)}};while(i<f.length){b=f[i++];c=f[i++];d=f[i++];e+=h[b>>2];e+=h[((b&3)<<4)|(c>>4)];e+=h[c===undefined?64:((c&15)<<2)|(d>>6)];e+=h[d===undefined?64:d&63]};return e};var getTLD=function(domain){if(!domain)return;if(/^(?:\d{1,3}\.){3}\d{1,3}$/.test(domain))return domain;var a=domain.split(''.'');var l=a.length;return(l<3)?domain:(a[l-2]+''.''+a[l-1])};var qualifyURL=function(w,url,onlyhost){var a=w.document.createElement(''a'');a.href=url;return onlyhost?((a.host.length<a.hostname.length)?a.host:a.hostname):(url?a.href:'''')};var getCookie=function(w,link){return(w.document.cookie&&getTLD(w.location.hostname)==getTLD(qualifyURL(w,link,true)))?w.document.cookie+''; '':''''};var getVideo=function(flashvars,src){var getLink=function(s){var a=s.match(/[^\s\x22=&?]+\.[^\s\x22=&?\/]*(flv|mp4)/i);return a?a[0]:''''};var getQuery=function(s,q){var a=s.match(new RegExp(''(^|[&?])''+q+''=([^&]+)''));return a?a[2]:''''};var getJson=function(s,q){var a=s.match(new RegExp(''\x22''+q+''\x22:\\s*(\x22.+?\x22)''));return a?eval(a[1]):''''};var getURL=function(f,s){return f.match(/^(\w+:\/\/|\/|$)/)?f:s.replace(/[#?].*$/,'''').replace(/[^\/]*$/,f)};var decodeURL=function(s){try{return decodeURIComponent(s)}catch(e){return unescape(s)}};var q='''',url=location.href,flv=decodeURL(flashvars);if(url.indexOf(''youtube.com/watch?'')!=-1&&(q=getQuery(flv,''url'')))return decodeURL(q)+''&signature=''+getQuery(flv,''sig'')+''&title=''+encodeURIComponent(document.title);if(url.indexOf(''video.google.com/videoplay?'')!=-1&&(q=getQuery(src,''videoUrl'')))return decodeURL(q);if(url.indexOf(''metacafe.com/watch/'')!=-1&&(q=getJson(flv,''mediaURL'')))return q+''?__gda__=''+getJson(flv,''value'');if(url.indexOf(''dailymotion.com/'')!=-1&&(q=getJson(flv,''hqURL'')||getJson(flv,''sdURL'')))return q;if(url.indexOf(''www.break.com/'')!=-1&&(q=getQuery(flv,''videoPath'')))return q+''?''+getQuery(flv,''icon'');if(url.indexOf(''my-hit.ru/film/'')!=-1&&(q=getLink(flv)))return q+''?start=0&id=''+getQuery(flv,''id'');return getURL(getLink(flv)||decodeURL(getLink(src)),src)};'
	$JsDownSel = $JsDownSel & 'var getParam=function(e,n){var v='''',r=new RegExp(''^(''+n+'')$'',''i'');var param=e.getElementsByTagName(''param'');for(var i=0,p;p=param[i];i++){if(r.test(p.getAttribute(''name''))){v=p.getAttribute(''value'');break}};return v};var trimStr=function(s){return s.replace(/\s+/g,'' '').replace(/^\s+|\s+$/g,'''')};var selWin=function(w){if(w.getSelection()!='''')return w;for(var i=0,f,r;f=w.frames[i];i++){try{if(r=arguments.callee(f))return r}catch(e){}}};var win=selWin(window)||window;var doc=win.document;var src,video,links='''',textLinks='''',n=0,rn=''\r\n'';var title=doc.getElementsByTagName(''title'').length?trimStr(doc.getElementsByTagName(''title'')[0].text):'''';var sel=doc.createElement(''div'');sel.appendChild(win.getSelection().getRangeAt(0).cloneContents());var obj=sel.getElementsByTagName(''object'');for(var i=0,oi;oi=obj[i];i++){src=oi.getAttribute(''data'')||oi.getAttribute(''src'')||getParam(oi,''movie|data|src|code|filename|url'')||(oi.getElementsByTagName(''embed'').length&&oi.getElementsByTagName(''embed'')[0].getAttribute(''src''));if(src){video=qualifyURL(win,getVideo(getParam(oi,''flashvars''),src));if(video){links+=video+rn+''[Video] ''+title+rn+getCookie(win,video)+rn+rn;n++};src=qualifyURL(win,src);links+=src+rn+''[Object] ''+title+rn+getCookie(win,src)+rn+rn;n++}};var em=sel.getElementsByTagName(''embed'');for(var i=0,ei;ei=em[i];i++){if(ei.parentNode.tagName.toLowerCase()!=''object''){src=ei.getAttribute(''src'');if(src){video=qualifyURL(win,getVideo(ei.getAttribute(''flashvars''),src));if(video){links+=video+rn+''[Video] ''+title+rn+getCookie(win,video)+rn+rn;n++};src=qualifyURL(win,src);links+=src+rn+''[Embed] ''+title+rn+getCookie(win,src)+rn+rn;n++}}};var l=sel.getElementsByTagName(''a'');for(var i=0,li;li=l[i];i++){if(li.protocol!=''javascript:''&&li.protocol!=''mailto:''){links+=li.href+rn+trimStr(li.innerText)+rn+getCookie(win,li.href)+rn+rn;n++}};var txt=(doc.getSelection&&doc.getSelection().toString())||window.inivar;window.inivar=null;if(!txt)return;txt=txt.replace(/^\s+|\s+$/g,'''').replace(/h..p:\/\//gi,''http://'').replace(/f.p:\/\//gi,''ftp://'');if(txt.indexOf(''://'')==-1&&/^\S+\/\S+$/.test(txt))txt=''http://''+txt;var t=txt.match(/((?:https|http|ftp|mms|rtsp):\/\/[^\s<>\x22]+)/gi);if(t){for(var i=0,ti;ti=t[i];i++){textLinks+=ti+rn+ti+rn+getCookie(win,ti)+rn+rn;n++}};var f=doc.createElement(''iframe'');f.width=0;f.height=0;f.frameBorder=''no'';f.scrolling=''no'';f.src=''data:text/ogt;charset=UTF-8;base64,''+encodeBase64(n+'';My_Download_Manager;2;;''+rn+win.location.href+rn+links+textLinks);doc.documentElement.appendChild(f);setTimeout(function(){f.parentNode.removeChild(f)},1)})()" "'
	
	$JsDownAll = '"Go to Page, "javascript:(function(){var encodeBase64=function(a){var b,c,d,e='''',f=[],i=0,j=0,g=0,h=''ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=''.split('''');while(g=a.charCodeAt(j++)){if(g<128){f[f.length]=g}else if(g<2048){f[f.length]=192|(g>>6);f[f.length]=128|(g&63)}else if(g<65536){f[f.length]=224|(g>>12);f[f.length]=128|((g>>6)&63);f[f.length]=128|(g&63)}else{f[f.length]=240|(g>>18);f[f.length]=128|((g>>12)&63);f[f.length]=128|((g>>6)&63);f[f.length]=128|(g&63)}};while(i<f.length){b=f[i++];c=f[i++];d=f[i++];e+=h[b>>2];e+=h[((b&3)<<4)|(c>>4)];e+=h[c===undefined?64:((c&15)<<2)|(d>>6)];e+=h[d===undefined?64:d&63]};return e};var getTLD=function(domain){if(!domain)return;if(/^(?:\d{1,3}\.){3}\d{1,3}$/.test(domain))return domain;var a=domain.split(''.'');var l=a.length;return(l<3)?domain:(a[l-2]+''.''+a[l-1])};var qualifyURL=function(w,url,onlyhost){var a=w.document.createElement(''a'');a.href=url;return onlyhost?((a.host.length<a.hostname.length)?a.host:a.hostname):(url?a.href:'''')};var getCookie=function(w,link){return(w.document.cookie&&getTLD(w.location.hostname)==getTLD(qualifyURL(w,link,true)))?w.document.cookie+''; '':''''};var getVideo=function(flashvars,src){var getLink=function(s){var a=s.match(/[^\s\x22=&?]+\.[^\s\x22=&?\/]*(flv|mp4)/i);return a?a[0]:''''};var getQuery=function(s,q){var a=s.match(new RegExp(''(^|[&?])''+q+''=([^&]+)''));return a?a[2]:''''};var getJson=function(s,q){var a=s.match(new RegExp(''\x22''+q+''\x22:\\s*(\x22.+?\x22)''));return a?eval(a[1]):''''};var getURL=function(f,s){return f.match(/^(\w+:\/\/|\/|$)/)?f:s.replace(/[#?].*$/,'''').replace(/[^\/]*$/,f)};var decodeURL=function(s){try{return decodeURIComponent(s)}catch(e){return unescape(s)}};var q='''',url=location.href,flv=decodeURL(flashvars);if(url.indexOf(''youtube.com/watch?'')!=-1&&(q=getQuery(flv,''url'')))return decodeURL(q)+''&signature=''+getQuery(flv,''sig'')+''&title=''+encodeURIComponent(document.title);if(url.indexOf(''video.google.com/videoplay?'')!=-1&&(q=getQuery(src,''videoUrl'')))return decodeURL(q);if(url.indexOf(''metacafe.com/watch/'')!=-1&&(q=getJson(flv,''mediaURL'')))return q+''?__gda__=''+getJson(flv,''value'');if(url.indexOf(''dailymotion.com/'')!=-1&&(q=getJson(flv,''hqURL'')||getJson(flv,''sdURL'')))return q;if(url.indexOf(''www.break.com/'')!=-1&&(q=getQuery(flv,''videoPath'')))return q+''?''+getQuery(flv,''icon'');if(url.indexOf(''my-hit.ru/film/'')!=-1&&(q=getLink(flv)))return q+''?start=0&id=''+getQuery(flv,''id'');return getURL(getLink(flv)||decodeURL(getLink(src)),src)};'
	$JsDownAll = $JsDownAll & 'var getParam=function(e,n){var v='''',r=new RegExp(''^(''+n+'')$'',''i'');var param=e.getElementsByTagName(''param'');for(var i=0,p;p=param[i];i++){if(r.test(p.getAttribute(''name''))){v=p.getAttribute(''value'');break}};return v};var trimStr=function(s){return s.replace(/\s+/g,'' '').replace(/^\s+|\s+$/g,'''')};var links='''',n=0,rn=''\r\n'';var downloadAll=function(w){if(w)try{var src,video,title=w.document.getElementsByTagName(''title'').length?trimStr(w.document.getElementsByTagName(''title'')[0].text):'''';var obj=w.document.getElementsByTagName(''object'');for(var i=0,oi;oi=obj[i];i++){src=oi.getAttribute(''data'')||oi.getAttribute(''src'')||getParam(oi,''movie|data|src|code|filename|url'')||(oi.getElementsByTagName(''embed'').length&&oi.getElementsByTagName(''embed'')[0].getAttribute(''src''));if(src){video=qualifyURL(w,getVideo(getParam(oi,''flashvars''),src));if(video){links+=video+rn+''[Video] ''+title+rn+getCookie(w,video)+rn+rn;n++};src=qualifyURL(w,src);links+=src+rn+''[Object] ''+title+rn+getCookie(w,src)+rn+rn;n++}};var em=w.document.getElementsByTagName(''embed'');for(var i=0,ei;ei=em[i];i++){if(ei.parentNode.tagName.toLowerCase()!=''object''){src=ei.getAttribute(''src'');if(src){video=qualifyURL(w,getVideo(ei.getAttribute(''flashvars''),src));if(video){links+=video+rn+''[Video] ''+title+rn+getCookie(w,video)+rn+rn;n++};src=qualifyURL(w,src);links+=src+rn+''[Embed] ''+title+rn+getCookie(w,src)+rn+rn;n++}}};var l=w.document.getElementsByTagName(''a'');for(var i=0,li;li=l[i];i++){if(li.protocol!=''javascript:''&&li.protocol!=''mailto:''){links+=li.href+rn+trimStr(li.innerText)+rn+getCookie(w,li.href)+rn+rn;n++}};for(var j=0,f;f=w.frames[j];j++){downloadAll(f)}}catch(e){}};downloadAll(window);var src=''data:text/ogt;charset=UTF-8;base64,''+encodeBase64(n+'';My_Download_Manager;2;;''+rn+location.href+rn+links);if(top==self){var f=document.createElement(''iframe'');f.width=0;f.height=0;f.frameBorder=''no'';f.scrolling=''no'';f.src=src;document.documentElement.appendChild(f);setTimeout(function(){f.parentNode.removeChild(f)},1)}else{location.href=src}})()",,,"Save" "'

	IniWrite($VarOperaMenu, "Link Popup Menu", 'Platform Windows, Item, ' & $MDL, $JsDownLink)
	IniWrite($VarOperaMenu, "Image Link Popup Menu", 'Platform Windows, Item, ' & $MDL, $JsDownLink)
	IniWrite($VarOperaMenu, "Links Panel Item Menu", 'Platform Windows, Item, ' & $MDL, $JsDownLink)
	
	If $Version >= 9.5 Then
		Transfer("Link Selection Popup Menu")
		IniWrite($VarOperaMenu, "Link Selection Popup Menu", 'Platform Windows, Item, ' & $MDL, $JsDownLink)
		IniWrite($VarOperaMenu, "Link Selection Popup Menu", 'Platform Windows, Item, ' & $MDS, $JsDownSel)
	EndIf
	
	If $Version >= 9 Then
		IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Закачать текстовую ссылку с oGet"')
		IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Закачать все картинки с oGet"')
		IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Download Text Link with oGet"')
		IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Download Selection with oGet"')
		IniWrite($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, ' & $MDS, $JsDownSel)
		
		IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, "Download All with oGet"')
		IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, "Download All Images with oGet"')
		IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, "Закачать все картинки с oGet"')
		IniWrite($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $MDALL, $JsDownAll)
		
		If $Version >= 9.2 And ($Version < 9.5 Or $Version > 9.6) And ($Version < 10.5 Or $Version > 11.0) Then IniWrite($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $MDAFTP, '"Execute program, "' & $DestDirUtf & 'oget.exe", "%S %u DOWNLOAD FTP",,"Attachment Archives" "')
		
		IniDelete($VarOperaMenu, "Link Popup Menu", 'Platform Windows, Item, ' & $MDL_USD)
		IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $MDALL_USD)
		IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, ' & $MDS_USD)
	Else
		IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Download with oGet"')
		IniDelete($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, "Закачать ссылку с oGet"')
		IniWrite($VarOperaMenu, "Hotclick Popup Menu", 'Platform Windows, Item, ' & $MDTL, '"Execute program, "' & $DestDirUtf & 'oget.exe", "%T %u %T",,"Save" "')
		
		IniDelete($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, "Download All with oGet"')
		IniWrite($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $MDALL, '"Execute program, "' & $DestDirUtf & 'oget.exe", "%S %u DOWNLOAD ALL",,"Save" "')
		IniWrite($VarOperaMenu, "Document Popup Menu", 'Platform Windows, Item, ' & $MDAI, '"Execute program, "' & $DestDirUtf & 'oget.exe", "%S %u DOWNLOAD IMG",,"Save" "')
	EndIf
	
EndFunc   ;==>Correct
