{ KOL MCK }// Do not remove this line!
{$DEFINE KOL_MCK}
unit Unit1;
 // oGet 2.5.15 by A.Ruzanov
 // 31.05.2009

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, KOL {$IF Defined(KOL_MCK)}{$ELSE}, mirror, Classes, Controls, mckControls, mckObjs, Graphics,  mckCtrls {$IFEND (place your units here->)}, RegExpr, KOLDDE, err, tlhelp32;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;
{$ENDIF}

type
  TEnumData = record
    ProcId: DWord;
    Wnd:    HWND;
  end;
  PEnumData = ^TEnumData;
  {$IF Defined(KOL_MCK)}
  {$I MCKfakeClasses.inc}
  {$IFDEF KOLCLASSES} {$I TForm1class.inc} {$ELSE OBJECTS} PForm1 = ^TForm1; {$ENDIF CLASSES/OBJECTS}
  {$IFDEF KOLCLASSES}{$I TForm1.inc}{$ELSE} TForm1 = object(TObj) {$ENDIF}
    Form:        PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$IFEND KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1:    TKOLForm;
    RadioBox1:   TKOLRadioBox;
    RadioBox2:   TKOLRadioBox;
    RadioBox3:   TKOLRadioBox;
    RadioBox4:   TKOLRadioBox;
    RadioBox5:   TKOLRadioBox;
    RadioBox6:   TKOLRadioBox;
    RadioBox7:   TKOLRadioBox;
    RadioBox8:   TKOLRadioBox;
    RadioBox9:   TKOLRadioBox;
    RadioBox10:  TKOLRadioBox;
    RadioBox11:  TKOLRadioBox;
    RadioBox12:  TKOLRadioBox;
    RadioBox13:  TKOLRadioBox;
    RadioBox14:  TKOLRadioBox;
    RadioBox15:  TKOLRadioBox;
    RadioBox16:  TKOLRadioBox;
    RadioBox17:  TKOLRadioBox;
    RadioBox18:  TKOLRadioBox;
    RadioBox19:  TKOLRadioBox;
    RadioBox20:  TKOLRadioBox;
    RadioBox21:  TKOLRadioBox;
    RadioBox22:  TKOLRadioBox;
    Button1:     TKOLButton;
    Button2:     TKOLButton;
    RadioBox23:  TKOLRadioBox;
    Button3:     TKOLButton;
    CheckBox1:   TKOLCheckBox;
    Panel1:      TKOLPanel;
    RadioBox24:  TKOLRadioBox;
    CheckBox2:   TKOLCheckBox;
    RadioBox25:  TKOLRadioBox;
    Panel2:      TKOLPanel;
    CheckBox3:   TKOLCheckBox;
    EditBox1:    TKOLEditBox;
    Label1:      TKOLLabel;
    RadioBox26:  TKOLRadioBox;
    Panel3:      TKOLPanel;
    RadioBox27:  TKOLRadioBox;
    RadioBox28:  TKOLRadioBox;
    procedure Button2Click(Sender: PObj);
    procedure RadioBox1Click(Sender: PObj);
    procedure Button1Click(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure RadioBox1Show(Sender: PObj);
    procedure Button1Show(Sender: PObj);
    procedure Button3Click(Sender: PObj);
    procedure CheckBox1Click(Sender: PObj);
    procedure CheckBox2Click(Sender: PObj);
    procedure KOLForm1BeforeCreateWindow(Sender: PObj);
    procedure CheckBox3Click(Sender: PObj);
    procedure EditBox1Show(Sender: PObj);
    procedure EditBox1Change(Sender: PObj);
    procedure Label1Click(Sender: PObj);
    procedure Panel1Click(Sender: PObj);
    procedure Panel2Click(Sender: PObj);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1 {$IFDEF KOL_MCK}: PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  DownloadManager, AllDM, USD, TransferToUSD, Custom, CustomDM,
  LangNeedRestart, LangCtrlClick, LangGetAll, LangNotGet, LangWait: string;
  FullInstall: integer;
  UsdExist, CustomDMEnabled: boolean;

{$IFDEF KOL_MCK}
procedure NewForm1(var Result: PForm1; AParent: PControl);
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I Unit1_1.inc}
{$ENDIF}

function ExtractOnlyFilePath(const Path: KOLString): KOLString;
var
  P, P0: PKOLChar;
begin
  P0 := PKOLChar(Path);
  P  := __DelimiterLast(P0, '\');
  if P^ = #0 then
    Result := ''
  else
    Result := Copy(Path, 1, P - P0 + 1);
end;

procedure CreateProc(const CommndLine: string; ShowCmd: integer;
  WaitInputIdle: boolean = True);

var
  pi:  TProcessInformation;
  si:  TStartupInfo;
  msg: TMsg;
  startdir: PChar;
begin
  startdir := PChar(ExcludeTrailingPathDelimiter(ExtractOnlyFilePath(CommndLine)));
  if not DirectoryExists(startdir) then
    startdir := nil;
  FillChar(si, SizeOf(si), #0);
  si.cb := SizeOf(si);
  si.dwFlags := STARTF_USESHOWWINDOW;
  si.wShowWindow := ShowCmd;
  if not CreateProcess(nil, //pointer to name of executable module
    PChar(CommndLine), // Command line.
    nil, // Process handle not inheritable.
    nil, // Thread handle not inheritable.
    False, // Set handle inheritance to FALSE.
    0,  // No creation flags.
    nil, // Use parent's environment block.
    startdir, // Use parent's starting directory.
    si, // Pointer to STARTUPINFO structure.
    pi) // Pointer to PROCESS_INFORMATION structure.
  then
    Exit;
  if WaitInputIdle then
    while WaitForInputIdle(PI.hProcess, 100) = WAIT_TIMEOUT do
      if PeekMessage(msg, 0, 0, 0, PM_REMOVE) then
      begin
        TranslateMessage(msg);
        DispatchMessage(msg);
      end;
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
end;

function PosEx(const SubStr, S: string; Offset: cardinal = 1): integer;
var
  I, X: integer;
  Len, LenSubStr: integer;
begin
  if Offset = 1 then
    Result := Pos(SubStr, S)
  else
  begin
    I := Offset;
    LenSubStr := Length(SubStr);
    Len := Length(S) - LenSubStr + 1;
    while I <= Len do
    begin
      if S[I] = SubStr[1] then
      begin
        X := 1;
        while (X < LenSubStr) and (S[I + X] = SubStr[X + 1]) do
          Inc(X);
        if (X = LenSubStr) then
        begin
          Result := I;
          exit;
        end;
      end;
      Inc(I);
    end;
    Result := 0;
  end;
end;

function ExpandEnvVars(const Str: string): string;
var
  Sz: integer; // size required for expanded string (excluding #0)
  Buffer: PChar;
begin
  Sz := ExpandEnvironmentStrings(PChar(Str), nil, 0);
  GetMem(Buffer, Sz);
  ExpandEnvironmentStrings(PChar(Str), Buffer, Sz);
  Result := Buffer;
  FreeMem(Buffer);
end;

function ReplaceStrToStr(Source: string; SourceSubStr, DestSubStr: string): string;
var
  I: integer;
begin
  Result := '';
  I := Pos(SourceSubStr, Source);
  while I <> 0 do
  begin
    Result := Result + Copy(Source, 1, I - 1) + DestSubStr;
    Delete(Source, 1, I - 1 + Length(SourceSubStr));
    I := Pos(SourceSubStr, Source);
  end;
  Result := Result + Source;
end;

function ExtractFileNameWithoutExt(const Path: KOLString): KOLString;
var
  P: PKOLChar;
begin
  P := __DelimiterLast(PKOLChar(Path), '\');
  if P^ = #0 then
    Result := Path
  else
    Result := P + 1;

  Result := Copy(Result, 1, Length(Result) - Length(ExtractFileExt(Result)));
end;

function Capitalize(const str: KOLString): KOLString;
var
  len: integer;
begin
  Result := '';
  len := Length(str);
  if len > 0 then
  begin
    SetString(Result, PChar(str), len);
    CharLowerBuffA(Pointer(Result), len);
    CharUpperBuffA(Pointer(Result), 1);
  end;
end;

function SearchDM: string;
var
  StartDir, str: string;
  StLst: PStrList;
var
  I: integer;
begin
  Result := '';
  StartDir := GetStartDir;
  AllDM  := '';
  ExecuteWait('"' + StartDir + 'FlashGot.exe"', ' -o "' + StartDir +
    'FlashGot.test"', StartDir, SW_HIDE, 100000, nil);

  StLst := NewStrList;
  StLst.LoadFromFile(StartDir + 'FlashGot.test');
  for I := 1 to StLst.Count - 1 do
  begin
    str := StLst.Items[I];
    if Pos('|OK', str) <> 0 then
    begin
      StrReplace(str, '|OK', '');
      Result := str;
      AllDM  := AllDM + str + ';';
    end;
  end;
  StLst.Free;

  if Result = '' then
    Result := 'No';
end;

function CorrectLink(const Str: string): string;
begin
  Result := Trim(Str);
  with TRegExpr.Create do
    try
      ModifierI := True;
      Result := ReplaceRegExpr('^_?[h]...[s]://', Result, 'https://');
      Result := ReplaceRegExpr('^_?[h]..[p]://', Result, 'http://');
      Result := ReplaceRegExpr('^_?[f].[p]://', Result, 'ftp://');
      Result := ReplaceRegExpr('^_?ftp\.', Result, 'ftp://ftp.');
      Result := ReplaceRegExpr('^www\.', Result, 'http://www.');
    finally
      Free;
    end;
end;

function HostName(const Str: string): string;
var
  P: integer;
begin
  Result := '';
  P := Pos('://', Str);
  if P <> 0 then
    Result := Copy(Str, 1, PosEx('/', Str, P + 3));
end;

function GetURLFromOpera(URL: string): string;
begin
  Result := '';
  with NewDDEClientConv(Form1.Form)^ do
  begin
    SetLink('Opera', 'WWW_GetWindowInfo');
    OpenLink;
    Result := RequestData('0xFFFFFFFF');
    CloseLink;
    Free;
  end;
  Result := Copy(Result, Pos('"', Result) + 1, Pos('","', Result) - 2);
  if Result = '' then
    Result := HostName(URL);
end;

function CorrectDesc(const St: string): string;
var
  I: integer;
  S: string;
begin
  S := St;
  for I := Length(S) downto 1 do
  begin
    if S[I] in ['<', '>', '|', #9, #10, #13] then
      S[I] := ' ';
    if S[I] = '"' then
      S[I] := '''';
  end;
  Result := Trim(Copy(S, 1, 1000));
end;

function CorrectRef(REF, URL, urls: string): string;
var
  domain, host, protocol: string;
  P: integer;
begin
  Result := REF;

  P := Pos('://', URL);
  if (P <> 0) and (HostName(REF) <> HostName(URL)) then
  begin
    protocol := Copy(URL, 1, P);
    Inc(P, 3);
    domain := Copy(URL, P, PosEx('/', URL, P) - P);

    while urls <> '' do
    begin
      host := Parse(urls, ';');
      if Pos(LowerCase(host), LowerCase(domain)) <> 0 then
      begin
        if Pos('.', host) = 1 then
          Result := protocol + '//' + domain + '/'
        else
          Result := protocol + '//' + host + '/';
        Break;
      end;
    end;
  end;
end;

//   USD
function TestUsdLink(const Str: string): boolean;
var
  tUsd: string;
begin
  Result := False;
  tUsd := TransferToUSD;
  while (tUsd <> '') and (Result = False) do
    Result := Pos(Parse(tUsd, ';'), Str) <> 0;
end;

function CorrectPath(const Str: string): string;
begin
  Result := ExpandEnvVars(Str);
  if (Result <> '') and (Pos(':\', Result) = 0) then
    Result := GetStartDir + Result;
end;

procedure fake(const AText: PChar); stdcall;
begin
end;

function fakeret(const AFuncName: PChar): Pointer; stdcall;
begin
  if (AFuncName = 'GetOption') or (AFuncName = 'SetOption') then
    Result := nil
  else
    Result := @fake;
end;

procedure RetResult(const AText: PChar); stdcall;
var
  str:  string;
  L, P: integer;
begin
  if Pos('%Error:', AText) = 1 then
    MessageBox(0, PChar(AText), 'oGet Error', 262160);
  str := LowerCase(ReplaceStrToStr(AText, #10, ';'));
  P := Pos('|', str);
  Delete(str, P, Length(str) - P + 1);
  str := IncludeTrailingChar(str, ';');
  while Pos('/', str) <> 0 do
  begin
    L := Pos('/', str);
    Delete(str, L, PosEx(';', str, L) - L);
  end;
  if Pos(str, TransferToUSD) = 0 then
    TransferToUSD := TransferToUSD + str;
end;

procedure SearchUsdServers;
type
  TPlgInit = procedure(const funcGet, funcPost, funcSaveToLog, funcGetFuncAddr,
      funcSaveToFile, funcRetResult: Pointer; const Debug: byte;
      const AWorkDir: PChar); stdcall;
  TPlgDestroy = procedure; stdcall;

var
  UsdDir, UsdPlug: string;
  SearchRec: TFindFileData;
  LibHandle: THandle;
  PlgInit: TPlgInit;
  PlgDestroy: TPlgDestroy;

begin
  TransferToUSD := '';
  UsdDir  := ExtractFilePath(CorrectPath(USD));
  UsdPlug := UsdDir + 'plugins\';
  if Find_First(UsdPlug + '*.plg', SearchRec) then
    repeat
      LibHandle := LoadLibrary(PChar(UsdPlug + SearchRec.cFileName));
      if LibHandle <> 0 then
      begin
        @PlgInit := GetProcAddress(LibHandle, 'PlgInit');
        @PlgDestroy := GetProcAddress(LibHandle, 'PlgDestroy');
        if (@PlgInit <> nil) and (@PlgDestroy <> nil) then
          try
            PlgInit(@fake, @fake, @fake, @fakeret, @fake, @RetResult, 0, PChar(UsdDir));
            PlgDestroy;
          except
          end;
        FreeLibrary(LibHandle);
      end;
    until not Find_Next(SearchRec);
  Find_Close(SearchRec);
end;


//   Opera
function GetParentId: DWord;
var
  ProcEntry: TProcessEntry32;
  hSnapshot: THandle;
  CurrID, ParentID: DWord;
begin
  Result := 0;
  ParentID := 0;
  hSnapshot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  if (hSnapshot <> INVALID_HANDLE_VALUE) then
    try
      ProcEntry.dwSize := SizeOf(ProcEntry);
      CurrID := GetCurrentProcessId;
      if Process32First(hSnapshot, ProcEntry) then
        repeat
          if ProcEntry.th32ProcessID = CurrID then
          begin
            ParentID := ProcEntry.th32ParentProcessID;
            Break;
          end;
        until not Process32Next(hSnapshot, ProcEntry);

      if ParentID > 0 then
        if Process32First(hSnapshot, ProcEntry) then
          repeat
            if ProcEntry.th32ProcessID = ParentID then
            begin
              Result := ParentID;
              Break;
            end;
          until not Process32Next(hSnapshot, ProcEntry);
    finally
      CloseHandle(hSnapshot);
    end;
end;

function FindOpera(Wnd: HWnd; Param: PEnumData): boolean; stdcall;
var
  WinText, WinClass: array[0..255] of char;
  WinTextLen, WinClassLen: integer;
  ProcessId: DWord;
begin
  Result := True;
  ProcessId := 0;
  if Param.ProcId > 0 then
    GetWindowThreadProcessId(Wnd, @ProcessId);
  if Param.ProcId = ProcessId then
  begin
    WinTextLen  := GetWindowText(Wnd, WinText, SizeOf(WinText));
    WinClassLen := GetClassName(Wnd, WinClass, SizeOf(WinClass));

    if isWindow(Wnd) and IsWindowVisible(Wnd) and (WinTextLen <> 0) and
      (WinClassLen <> 0) then
      Result := ((WinClass <> 'OpWindow') and (WinClass <> 'OperaWindowClass')) or
        (WinText = '');
  end;
  if not Result then
    Param.Wnd := Wnd;
end;

function TopDir: string;
var
  OperaDir: string;
  oGetIni:  pIniFile;
begin
  oGetIni  := OpenIniFile(GetStartDir + 'oGet.ini');
  oGetIni.Mode := ifmRead;
  oGetIni.Section := 'Main';
  OperaDir := oGetIni.ValueString('OperaDir', '');
  oGetIni.Free;

  if OperaDir = '' then
  begin
    Result := ExcludeTrailingPathDelimiter(GetStartDir);
    DeleteTail(Result, Length(Result) - DelimiterLast(Result, '\'));
  end
  else
    Result := CorrectPath(OperaDir);

  Result := ExcludeTrailingPathDelimiter(Result);
end;

function OpExe: string;
var
  op, oac, opt, opdir: string;
begin
  opdir := TopDir;
  op  := opdir + '\Opera.exe';
  oac := opdir + '\OperaAC.exe';
  opt := opdir + '\OperaPortable.exe';

  if FileExists(oac) then
    Result := oac
  else if FileExists(opt) then
    Result := opt
  else if FileExists(op) then
    Result := op;
end;

procedure SetCheckBox1(inst: TTriStateCheck);
begin
  case inst of
    tsChecked:
    begin
      Form1.CheckBox1.Check3  := tsIndeterminate;
      Form1.CheckBox1.Caption := LangCtrlClick;
    end;
    tsIndeterminate:
    begin
      Form1.CheckBox1.Check3  := tsUnchecked;
      Form1.CheckBox1.Caption := LangNotGet;
    end;
    tsUnchecked:
    begin
      Form1.CheckBox1.Check3  := tsChecked;
      Form1.CheckBox1.Caption := LangGetAll;
    end;
  end;
end;

procedure FullInst(inst: TTriStateCheck);
var
  ODefIni, O6Ini, oGetIni: pIniFile;
  PathO6, AppDataPath, NameDir, UTFStartDir, UserJS, OgetPath, capt,
  o6Name, oDef6Path: string;
  Stream: PStream;
  MultiUser, NeedRestart, RunOp, UserJavaScript, isOpera10: boolean;
  RecOpera: TEnumData;
  K: HKEY;
  time: dword;
  msg: TMsg;
begin
  // Path
  UTFStartDir := AnsiToUtf8(GetStartDir);
  OgetPath := AnsiToUtf8(ParamStr(0));
  NameDir  := TopDir;
  isOpera10 := FileExists(NameDir + '\operaprefs_default.ini');
  if isOpera10 then
  begin
    o6Name := 'operaprefs.ini';
    oDef6Path := NameDir + '\operaprefs_default.ini';
  end
  else
  begin
    o6Name := 'opera6.ini';
    oDef6Path := NameDir + '\operadef6.ini';
  end;
  ODefIni := OpenIniFile(oDef6Path);
  ODefIni.Mode := ifmRead;
  ODefIni.Section := 'System';
  MultiUser := ODefIni.ValueBoolean('Multi User', True);
  ODefIni.Free;


  if not MultiUser then
    PathO6 := NameDir + '\profile\' + o6Name
  else
  begin
    K := RegKeyOpenRead(HKEY_CURRENT_USER,
      'SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders');
    AppDataPath := RegKeyGetStr(K, 'AppData');
    RegKeyClose(K);
    NameDir := CopyEnd(NameDir, DelimiterLast(NameDir, '\') + 1);
    PathO6  := IncludeTrailingPathDelimiter(AppDataPath + '\opera\' + NameDir);
    if isOpera10 then
      PathO6 := PathO6 + o6Name
    else
      PathO6 := PathO6 + 'profile\' + o6Name;
  end;

  if not FileExists(PathO6) then
  begin
    SetCheckBox1(inst);
    Exit;
  end;

  // UserJS
  O6Ini  := OpenIniFile(PathO6);
  O6Ini.Mode := ifmRead;
  O6Ini.Section := 'State';
  RunOp  := O6Ini.ValueBoolean('Run', False);
  O6Ini.Section := 'User Prefs';
  UserJavaScript := O6Ini.ValueBoolean('User JavaScript', False);
  UserJS := Utf8ToAnsi(O6Ini.ValueString('User JavaScript File', ''));
  O6Ini.Free;

  CopyFile(PChar(PathO6), PChar(PathO6 + '.bak'), False);
  RecOpera.ProcId := GetParentId;
  EnumWindows(@FindOpera, longint(@RecOpera));
  RunOp := RunOp and (RecOpera.Wnd <> 0);
  NeedRestart := RunOp and ((inst <> tsIndeterminate) or (not UserJavaScript));

  if (not RunOp) and (not UserJavaScript) and (inst <> tsUnchecked) then
  begin
    UserJS := PathO6;
    StrReplace(UserJS, o6Name, 'userjs');
    CreateDir(UserJS);
    O6Ini := OpenIniFile(PathO6);
    O6Ini.Mode := ifmWrite;
    O6Ini.Section := 'User Prefs';
    O6Ini.ValueBoolean('User JavaScript', True);
    O6Ini.ValueBoolean('Always Load User JavaScript', True);
    O6Ini.ValueString('User JavaScript File', AnsiToUtf8(UserJS));
    O6Ini.Free;
  end;

  if NeedRestart then
  begin
    if MessageBox(Applet.Handle, PChar(LangNeedRestart), 'oGet', 270385) = idOk then
    begin
      SendMessage(RecOpera.Wnd, WM_CLOSE, 0, 0);
      time := GetTickCount + 30000;

      //    SetForegroundWindow(OpWnd);
      //    While (GetForegroundWindow <> OpWnd) And (GetTickCount < time) Do Sleep(200);
      //    keybd_event(VK_CONTROL, 0, 0, 0);
      //    keybd_event($51 , 0, 0, 0);
      //    Sleep(50);
      //    keybd_event($51 , 0, KEYEVENTF_KEYUP, 0);
      //    keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);

      capt := Form1.CheckBox1.Caption;
      Form1.CheckBox1.Caption := LangWait;
      Form1.Panel1.Enabled := False;
      Form1.Panel2.Enabled := False;
      repeat
        Sleep(1000);
        while PeekMessage(msg, 0, 0, 0, PM_REMOVE) do
        begin
          TranslateMessage(msg);
          DispatchMessage(msg);
        end;
        O6Ini := OpenIniFile(PathO6);
        O6Ini.Mode := ifmRead;
        O6Ini.Section := 'State';
        RunOp := O6Ini.ValueBoolean('Run', False);
        O6Ini.Free;
        Sleep(1000);
      until (not RunOp) or (GetTickCount > time);
      Form1.Panel1.Enabled := True;
      Form1.Panel2.Enabled := True;
      Form1.CheckBox1.Caption := capt;
      if not UserJavaScript then
      begin
        UserJS := PathO6;
        StrReplace(UserJS, o6Name, 'userjs');
        CreateDir(UserJS);
        O6Ini := OpenIniFile(PathO6);
        O6Ini.Mode := ifmWrite;
        O6Ini.Section := 'User Prefs';
        O6Ini.ValueBoolean('User JavaScript', True);
        O6Ini.ValueBoolean('Always Load User JavaScript', True);
        O6Ini.ValueString('User JavaScript File', AnsiToUtf8(UserJS));
        O6Ini.Free;
      end;
    end
    else
    begin
      SetCheckBox1(inst);
      Exit;
    end;
  end;

  if inst <> tsUnchecked then
  begin
    if DirectoryExists(UserJS) then
    begin
      Stream := NewWriteFileStream(IncludetrailingPathDelimiter(UserJS) + 'oGet.js');
      Resource2Stream(Stream, hInstance, PChar('OGETJS'), RT_RCDATA);
      Stream.Free;
      if inst = tsIndeterminate then
        FullInstall := 3;
    end;
  end;

  RecOpera.ProcId := GetParentId;
  EnumWindows(@FindOpera, longint(@RecOpera));
  O6Ini := OpenIniFile(PathO6);
  O6Ini.Mode := ifmRead;
  O6Ini.Section := 'State';
  RunOp := O6Ini.ValueBoolean('Run', False) and (RecOpera.Wnd <> 0);
  O6Ini.Mode := ifmWrite;
  O6Ini.Section := 'File Types';

  if not RunOp then
  begin
    if inst = tsChecked then
    begin
      O6Ini.ValueString('text/ogt', '3,' + OgetPath + ',,,,|');
      O6Ini.ValueString('application/x-arj', '7,' + OgetPath + ',,,arj,|');
      O6Ini.ValueString('application/x-rar-compressed', '7,' + OgetPath + ',,,rar,|');
      O6Ini.ValueString('application/x-zip-compressed', '7,' + OgetPath + ',,,zip,|');
      O6Ini.ValueString('application/x-7z-compressed', '7,' + OgetPath + ',,,7z,|');
      O6Ini.ValueString('application/zip', '7,' + OgetPath + ',,,zip,|');
      O6Ini.ValueString('application/x-msdownload',
        '7,' + OgetPath + ',,,exe,bat,pif,com,scr,|');
      O6Ini.ValueString('application/x-msdos-program',
        '7,' + OgetPath + ',,,exe,bat,pif,com,scr,|');
      O6Ini.ValueString('application/x-msi', '7,' + OgetPath + ',,,msi,|');
      O6Ini.ValueString('application/octet-stream', '7,' + OgetPath + ',,,,|');
      O6Ini.ValueString('application/x-compress', '7,' + OgetPath + ',,,z,|');
      O6Ini.ValueString('application/x-gtar', '7,' + OgetPath + ',,,gtar,|');
      O6Ini.ValueString('application/x-gzip', '7,' + OgetPath + ',,,gz,gzip,tgz,|');
      O6Ini.ValueString('application/bzip2', '7,' + OgetPath + ',,,bz2,|');
      O6Ini.ValueString('application/x-tar', '7,' + OgetPath + ',,,tar,tgz,gz,bz2,|');
      FullInstall := 1;

      O6Ini.Mode := ifmRead;
      if (O6Ini.ValueString('audio/mpeg', '0,,,,mp3,mp2,mpga,|') = '0,,,,mp3,mp2,mpga,|') and
        (O6Ini.ValueString('video/mpeg', '0,,,,mpeg,mpg,mpe,m2v,m1v,mpa,|') =
        '0,,,,mpeg,mpg,mpe,m2v,m1v,mpa,|') and
        (O6Ini.ValueString('video/x-msvideo', '0,,,,avi,|') = '0,,,,avi,|') and
        (O6Ini.ValueString('video/quicktime', '0,,,,qt,mov,|') = '0,,,,qt,mov,|') then
      begin
        O6Ini.Mode := ifmWrite;
        O6Ini.ValueString('audio/mpeg', '7,' + OgetPath + ',,,mp3,mp2,mpga,|');
        O6Ini.ValueString('video/mpeg', '7,' + OgetPath + ',,,mpeg,mpg,mpe,m2v,m1v,mpa,|');
        O6Ini.ValueString('video/x-msvideo', '7,' + OgetPath + ',,,avi,|');
        O6Ini.ValueString('video/quicktime', '7,' + OgetPath + ',,,qt,mov,|');
        FullInstall := 2;
      end;

      O6Ini.Section := 'File Types Section Info';
      O6Ini.ValueInteger('Version', 2);
      O6Ini.Section := 'File Types Extension';
      O6Ini.ValueString('text/ogt', ',0');

    end
    else if inst = tsUnchecked then
    begin
      O6Ini.ValueString('application/x-arj', '0,,,,arj,|');
      O6Ini.ValueString('application/x-rar-compressed', '0,,,,rar,|');
      O6Ini.ValueString('application/x-zip-compressed', '0,,,,zip,|');
      O6Ini.ValueString('application/x-7z-compressed', '0,,,,7z,|');
      O6Ini.ValueString('application/zip', '0,,,,zip,|');
      O6Ini.ValueString('application/x-msdownload', '0,,,,exe,bat,pif,com,scr,|');
      O6Ini.ValueString('application/x-msdos-program', '0,,,,exe,bat,pif,com,scr,|');
      O6Ini.ValueString('application/x-msi', '0,,,,msi,|');
      O6Ini.ValueString('application/octet-stream', '0,,,,,|');
      O6Ini.ValueString('application/x-compress', '0,,,,z,|');
      O6Ini.ValueString('application/x-gtar', '0,,,,gtar,|');
      O6Ini.ValueString('application/x-gzip', '0,,,,gz,gzip,tgz,|');
      O6Ini.ValueString('application/bzip2', '0,,,,bz2,|');
      O6Ini.ValueString('application/x-tar', '0,,,,tar,tgz,gz,bz2,|');

      if FullInstall = 2 then
      begin
        O6Ini.ValueString('audio/mpeg', '0,,,,mp3,mp2,mpga,|');
        O6Ini.ValueString('video/mpeg', '0,,,,mpeg,mpg,mpe,m2v,m1v,mpa,|');
        O6Ini.ValueString('video/x-msvideo', '0,,,,avi,|');
        O6Ini.ValueString('video/quicktime', '0,,,,qt,mov,|');
      end;
      if FileExists(UserJS + '\oGet.js') then
        if CopyFile(PChar(UserJS + '\oGet.js'), PChar(UserJS + '\oGet.js.xx'), False) then
          DeleteFile(PChar(UserJS + '\oGet.js'));
      FullInstall := 0;
    end;
  end;
  O6Ini.Free;

  oGetIni := OpenIniFile(GetStartDir + 'oGet.ini');
  oGetIni.Mode := ifmWrite;
  oGetIni.Section := 'Main';
  oGetIni.ValueInteger('FullInstall', FullInstall);
  oGetIni.Free;
  if NeedRestart then
    CreateProc(OpExe, SW_SHOW, False);
end;

procedure UpdatePanel;
var
  d: string;
  i: integer;
begin
  d := SearchDM;
  for i := 0 to Form1.Panel1.ChildCount - 1 do
  begin
    if Pos(Form1.Panel1.Children[i].Caption + ';', AllDM) = 0 then
    begin
      Form1.Panel1.Children[i].Enabled := False;
      if Form1.Panel1.Children[i].Caption = DownloadManager then
        DownloadManager := d;
    end
    else
      Form1.Panel1.Children[i].Enabled := True;
  end;

  for i := 0 to Form1.Panel1.ChildCount - 1 do
    if Form1.Panel1.Children[i].Caption = DownloadManager then
      Form1.Panel1.Children[i].Checked := True
    else
      Form1.Panel1.Children[i].Checked := False;

end;

function CorrectDescription(const S: string): string;
var
  Str: string;
  I, h, e: integer;
begin
  Str := S;
  for I := Length(Str) downto 1 do
    if Str[I] in [#9, #10, #13] then
      Str[I] := ' ';
  while (Length(Str) > 0) do
  begin
    h := Pos('<', Str);
    if h = 0 then
      Break;
    e := PosEx('>', Str, h + 1);
    if e = 0 then
      Break;
    Delete(Str, h, e - h + 1);
  end;
  Result := Trim(Str);
end;

function CorrectEntities(const S: string): string;
const
  Entities: array [1..10, 1..4] of string = (
    ('&quot;', '&#34;', '&#034;', '"'),
    ('&amp;', '&#38;', '&#038;', '&'),
    ('&apos;', '&#39;', '&#039;', ''''),
    ('&lt;', '&#60;', '&#060;', '<'),
    ('&gt;', '&#62;', '&#062;', '>'),
    ('&copy;', '&#169;', '&#xA9;', #194#169),
    ('&laquo;', '&#171;', '&#xAB;', #194#171),
    ('&reg;', '&#174;', '&#xAE;', #194#174),
    ('&raquo;', '&#187;', '&#xBB;', #194#187),
    ('&ndash;', '&mdash;', '&minus;', '-'));

var
  Str: string;
  I: integer;
begin
  Str := S;
  for I := Low(Entities) to High(Entities) do
  begin
    Str := ReplaceStrToStr(Str, Entities[I, 1], Entities[I, 4]);
    Str := ReplaceStrToStr(Str, Entities[I, 2], Entities[I, 4]);
    Str := ReplaceStrToStr(Str, Entities[I, 3], Entities[I, 4]);
  end;
  Result := Str;
end;

function CorrectHref(const S: string): string;
var
  len, I: integer;
begin
  Result := S;
  len := Length(S);
  if len > 0 then
  begin
    for I := 1 to len do
      if Result[I] in [#9, #10, #13] then
        Result[I] := ' ';
    if ((Result[1] = '"') and (Result[len] = '"')) or
      ((Result[1] = '''') and (Result[len] = '''')) then
      Result := Copy(Result, 2, len - 2);
  end;
end;

function Clipboard2Html: string;
var
  gbl: THandle;
  str: PChar;
  CF_HTML: UINT;
begin
  Result := '';
  if OpenClipboard(0) then
  begin
    CF_HTML := RegisterClipboardFormat('HTML Format');
    if IsClipboardFormatAvailable(CF_HTML) then
    begin
      gbl := GetClipboardData(CF_HTML);
      if gbl <> 0 then
      begin
        str := GlobalLock(gbl);
        if str <> nil then
        begin
          Result := CopyEnd(str, Pos('<', str));
          GlobalUnlock(gbl);
        end;
      end;
    end
    else
    if IsClipboardFormatAvailable(CF_TEXT) then
    begin
      gbl := GetClipboardData(CF_TEXT);
      if gbl <> 0 then
      begin
        str := GlobalLock(gbl);
        if str <> nil then
        begin
          Result := AnsiToUtf8(str);
          GlobalUnlock(gbl);
        end;
      end;
    end;
    CloseClipboard;
  end;
end;

procedure DownloadAll(fileFrom, url, all, fileTo: string);
var
  content, lnk, hn, pn: string;
  Source: PStream;
  linksList: PStrList;
  Sz:  cardinal;
  buf: array [1..2] of byte;
  isNotUtf: boolean;

begin
  isNotUtf := False;

  if fileFrom <> 'CLIPBOARD' then
  begin
    Source := NewReadFileStream(fileFrom);
    try
      Sz := Source.Size;
      if (Sz = DWord(-1)) or (Source.Read(buf, 2) <> 2) then
        Exit;
      if (buf[1] = 255) and (buf[2] = 254) then
        content := Utf8Encode(Source.ReadWStrZ)
      else
      begin
        content  := Source.ReadStrZ;
        isNotUtf := True;
      end;
    finally
      Source.Free;
    end;
  end
  else
    content := Clipboard2Html;

  content := ReplaceStrToStr(ReplaceStrToStr(ReplaceStrToStr(content, '&nbsp;', ' '),
    '&#160;', ' '), '&#xA0;', ' ');


  with TRegExpr.Create do
    try
      ModifierI := True;
      ModifierS := True;

      if isNotUtf then
      begin
        Expression := '<meta[^>]+charset\s*=\s*utf-8[^>]*>';
        if not Exec(content) then
          content := AnsiToUtf8(content);
      end;

      hn := ExcludeTrailingChar(HostName(url), '/');
      pn := url;
      DeleteTail(pn, Length(pn) - DelimiterLast(pn, '/'));
      pn := IncludeTrailingChar(pn, '/');

      linksList := NewStrList;

      if all = 'IMG' then
      begin
        Expression := '<(img|embed)[^<>]+?src\s*=\s*(("[^<>"]*")|(''[^<>'']*'')|([^<> ]*)).*?>';
        if Exec(content) then
          repeat
            lnk := CorrectHref(Match[2]);
            if (lnk <> '') then
            begin
              if Pos('://', lnk) = 0 then
                if Pos('/', lnk) = 1 then
                  lnk := hn + lnk
                else
                  lnk := pn + lnk;
              if linksList.IndexOf(lnk) = -1 then
              begin
                linksList.Add(lnk);
                linksList.Add('');
                linksList.Add('');
                linksList.Add('');
              end;
            end;
          until not ExecNext;
      end
      else
      begin
        Expression :=
          '<a[^<>]+?href\s*=\s*(("[^<>"]*")|(''[^<>'']*'')|([^<> ]*))[^<>]*>(.*?)</a>';
        if Exec(content) then
          repeat
            lnk := CorrectHref(Match[1]);
            if (lnk <> '') and (Pos('javascript:', lnk) = 0) and
              (Pos('mailto:', lnk) = 0) and (Pos('opera:', lnk) = 0) then
            begin
              if Pos('://', lnk) = 0 then
                if Pos('/', lnk) = 1 then
                  lnk := hn + lnk
                else
                  lnk := pn + lnk;
              if linksList.IndexOf(lnk) = -1 then
              begin
                linksList.Add(lnk);
                linksList.Add(CorrectDescription(Match[5]));
                linksList.Add('');
                linksList.Add('');
              end;
            end;
          until not ExecNext;

        Expression := '[^="''/]h.{2,4}p://([^\s<>"]+)';
        if Exec(content) then
          repeat
            lnk := Match[1];
            if lnk <> '' then
            begin
              lnk := 'http://' + lnk;
              if linksList.IndexOf(lnk) = -1 then
              begin
                linksList.Add(lnk);
                linksList.Add(lnk);
                linksList.Add('');
                linksList.Add('');
              end;
            end;
          until not ExecNext;
      end;

      linksList.Text := CorrectEntities(linksList.Text);
      linksList.Insert(0, Int2Str(linksList.Count div 4) + ';My_Download_Manager;2;;');
      linksList.Insert(1, url);
      linksList.SaveToFile(fileTo);
      linksList.Free;
    finally
      Free;
    end;
end;


procedure TForm1.Button2Click(Sender: PObj);
begin
  Form.Close;
end;

//  
procedure TForm1.Button1Click(Sender: PObj);
var
  oGetIni: pIniFile;
  poz: integer;
begin
  oGetIni := OpenIniFile(GetStartDir + 'oGet.ini');
  oGetIni.Mode := ifmWrite;
  oGetIni.Section := 'Main';
  oGetIni.ValueString('DM', DownloadManager);
  if AllDM <> '' then
    oGetIni.ValueString('AllDM', AllDM);
  oGetIni.ValueString('CustomDM', CustomDM);
  oGetIni.ValueBoolean('CustomDMEnabled', CheckBox3.Checked);
  oGetIni.ValueString('USD', USD);
  if UsdExist then
  begin
    if (Length(TransferToUSD) > 4000) then
    begin
      poz := 4000;
      while ((poz > 2000) and (TransferToUSD[poz] <> ';')) do
        Dec(poz);

      oGetIni.ValueString('TransferToUSD', Copy(TransferToUSD, 1, poz));
      oGetIni.ValueString('TransferToUSDs', Copy(TransferToUSD, poz + 1,
        Length(TransferToUSD)));
    end
    else
      oGetIni.ValueString('TransferToUSD', TransferToUSD);
  end;
  oGetIni.ValueInteger('FullInstall', FullInstall);
  oGetIni.Section := 'Position';
  oGetIni.ValueInteger('Left', Form.Left);
  oGetIni.ValueInteger('Top', Form.Top);
  oGetIni.Free;
  Form.Close;
end;

procedure TForm1.RadioBox1Click(Sender: PObj);
begin
  DownloadManager := TKOLRadioBox(Sender).Caption;
  EditBox1.Visible := False;
  Label1.Visible  := True;
  CheckBox3.Checked := False;
  Button1.Focused := True;
end;


procedure TForm1.KOLForm1FormCreate(Sender: PObj);
var
  StartDir, FgtPath, txt, OrigTxt, PathDM, Rkey, URL, REF, DESC,
  COOK, POST, First, ToCustomDM, UsdUrl, UsdLinks, NumLinks, UsdCorr,
  Lang, OK, Cancel, Refresh, Param1, Param2, Param3, Param4,
  ToolTipIntegration, ToolTipCustom, ToolTipUsd, FixReferrer: string;
  kDM, NumStr, j, poz: integer;
  oGetIni, oGetLangIni: pIniFile;
  TxtLst: PStrList;
  NotNeedDM, TestREF, NeedSearchDM, Advanced, UseDDE: boolean;

begin
  //  
  NeedSearchDM := True;
  StartDir := GetStartDir;
  FgtPath  := StartDir + 'flashgot.fgt';

  oGetIni := OpenIniFile(StartDir + 'oGet.ini');
  oGetIni.Mode := ifmRead;
  oGetIni.Section := 'Main';
  DownloadManager := oGetIni.ValueString('DM', '');
  AllDM := oGetIni.ValueString('AllDM', '');
  CustomDM := oGetIni.ValueString('CustomDM', '');
  CustomDMEnabled := oGetIni.ValueBoolean('CustomDMEnabled', False);
  USD := oGetIni.ValueString('USD', '');
  UsdCorr := CorrectPath(USD);

  if FileExists(UsdCorr) then
    UsdExist := True
  else
    UsdExist := False;
  TransferToUSD := oGetIni.ValueString('TransferToUSD', '') +
    oGetIni.ValueString('TransferToUSDs', '');
  FullInstall := oGetIni.ValueInteger('FullInstall', 0);
  Advanced := oGetIni.ValueBoolean('Advanced', True);
  UseDDE := oGetIni.ValueBoolean('UseDDE', True);
  Lang := oGetIni.ValueString('Language', 'en');
  FixReferrer := oGetIni.ValueString('FixReferrer',
    'sourceforge.net;.narod.ru;files.myopera.com;');
  oGetIni.Section := 'Position';
  Form.Left := oGetIni.ValueInteger('Left', Form.Left);
  Form.Top := oGetIni.ValueInteger('Top', Form.Top);

  oGetLangIni := OpenIniFile(StartDir + 'oGet_lang.ini');
  oGetLangIni.Mode := ifmRead;
  oGetLangIni.Section := Lang;
  OK := Utf8ToAnsi(oGetLangIni.ValueString('10', 'OK'));
  Cancel := Utf8ToAnsi(oGetLangIni.ValueString('11', 'Cancel'));
  Refresh := Utf8ToAnsi(oGetLangIni.ValueString('12', 'Refresh'));
  // Full_integration := Utf8ToAnsi(oGetLangIni.ValueString('13', 'Full integration with Opera'));
  // Close_Opera := Utf8ToAnsi(oGetLangIni.ValueString('14', 'Please, close Opera, not oGet!'));
  Custom := Utf8ToAnsi(oGetLangIni.ValueString('15', 'Custom download manager'));

  LangNotGet := Utf8ToAnsi(oGetLangIni.ValueString('16', 'Don''t catch links'));
  LangGetAll := Utf8ToAnsi(oGetLangIni.ValueString('17', 'Catch all links'));
  LangCtrlClick := Utf8ToAnsi(oGetLangIni.ValueString('18', 'Catch links via Ctrl+Click'));
  LangNeedRestart := Utf8ToAnsi(oGetLangIni.ValueString('19',
    'The browser will be restarted. Continue?'));
  LangWait := Utf8ToAnsi(oGetLangIni.ValueString('20', 'Please wait...'));

  ToolTipCustom := Utf8ToAnsi(oGetLangIni.ValueString('21', ''));
  ToolTipIntegration := Utf8ToAnsi(oGetLangIni.ValueString('22', ''));
  ToolTipUsd := Utf8ToAnsi(oGetLangIni.ValueString('23', ''));
  oGetLangIni.Free;

  Button1.Caption := OK;
  Button2.Caption := Cancel;
  if Advanced then
  begin
    Button3.Hint.Text := Refresh;
    if ToolTipIntegration <> '' then
      CheckBox1.Hint.Text := ToolTipIntegration;
    if ToolTipUsd <> '' then
      CheckBox2.Hint.Text := ToolTipUsd;
    if ToolTipCustom <> '' then
      CheckBox3.Hint.Text := ToolTipCustom;
  end;

  if FileExists(TopDir + '\opera.dll') then
    case FullInstall of
      0:
      begin
        CheckBox1.Check3  := tsUnchecked;
        CheckBox1.Caption := LangNotGet;
      end;
      3:
      begin
        CheckBox1.Check3  := tsIndeterminate;
        CheckBox1.Caption := LangCtrlClick;
      end;
      else
      begin
        CheckBox1.Check3  := tsChecked;
        CheckBox1.Caption := LangGetAll;
      end;
    end
  else
  begin
    CheckBox1.Visible := False;
    Panel3.Visible := True;
    UseDDE := False;
  end;

  if (CustomDM = '') then
    Label1.Text := Custom
  else
    Label1.Text := Capitalize(ExtractFileNameWithoutExt(CustomDM));


  if DownloadManager = '' then
  begin
    DownloadManager := SearchDM;
    oGetIni.Mode := ifmWrite;
    oGetIni.Section := 'Main';
    oGetIni.ValueString('DM', DownloadManager);
    oGetIni.ValueString('AllDM', AllDM);
    NeedSearchDM := False;
  end;

  if UsdExist and (TransferToUSD = '') then
  begin
    SearchUsdServers;
    oGetIni.Mode := ifmWrite;
    oGetIni.Section := 'Main';
    if (Length(TransferToUSD) > 4000) then
    begin
      poz := 4000;
      while ((poz > 2000) and (TransferToUSD[poz] <> ';')) do
        Dec(poz);

      oGetIni.ValueString('TransferToUSD', Copy(TransferToUSD, 1, poz));
      oGetIni.ValueString('TransferToUSDs', Copy(TransferToUSD, poz + 1,
        Length(TransferToUSD)));
    end
    else
      oGetIni.ValueString('TransferToUSD', TransferToUSD);
  end;
  oGetIni.Free;

  //  
  if ParamCount > 0 then
  begin
    Param1 := ParamStr(1);
    Param2 := ParamStr(2);
    Param3 := ParamStr(3);
    Param4 := ParamStr(4);
    if (Pos('\', Param1) = 0) and (Pos('/', Param1) <> 0) then
    begin
      REF  := '';
      DESC := '';
      if Advanced and (ParamCount = 1) then
      begin
        OrigTxt := Clipboard2Text;
        keybd_event(VK_CONTROL, 0, 0, 0);
        keybd_event(VK_INSERT, 0, 0, 0);
        keybd_event(VK_INSERT, 0, KEYEVENTF_KEYUP, 0);
        keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
        sleep(50);
        txt := Clipboard2Text;
        if txt <> OrigTxt then
        begin
          DESC := AnsiToUtf8(ReplaceStrToStr(txt, #13#10, ' '));
          if OrigTxt <> '' then
            Text2Clipboard(OrigTxt);
        end;
      end;
      URL := CorrectLink(Param1);
      if ParamCount > 1 then
        REF := Param2
      else if UseDDE then
        REF := GetURLFromOpera(URL)
      else
        REF := HostName(URL);
      URL := AnsiToUtf8(URL);
      REF := AnsiToUtf8(REF);
      if ParamCount > 2 then
        DESC := AnsiToUtf8(ReplaceStrToStr(Param3, #13#10, ' '));
      StrSaveToFile(FgtPath, '1;My_Download_Manager;0;;' + #13#10 + REF +
        #13#10 + URL + #13#10 + DESC + #13#10#13#10#13#10);
    end
    else
    begin
      if (ParamCount = 4) and (Param3 = 'DOWNLOAD') and (Length(Param4) = 3) then
        DownloadAll(Param1, Param2, Param4, FgtPath)
      else
      begin
        FgtPath := Param1;
        if (not FileExists(FgtPath)) or (FileSize(FgtPath) > 1000000) then
        begin
          MessageBox(0, PChar('Not exist file "' + FgtPath + '"'), 'oGet Error', 262160);
          Halt;
        end;
      end;
    end;

    TxtLst := NewStrList;
    TxtLst.LoadFromFile(FgtPath);
    NumStr := TxtLst.Count;
    if NumStr > 5 then
    begin
      First := TxtLst.Items[0];
      REF  := TxtLst.Items[1];
      URL  := TxtLst.Items[2];
      DESC := TxtLst.Items[3];
      COOK := TxtLst.Items[4];
      POST := TxtLst.Items[5];

      StrReplace(First, 'My_Download_Manager', DownloadManager);
      REF := CorrectRef(REF, URL, FixReferrer);
      NotNeedDM := False;

      //    USD
      if UsdExist then
      begin
        if (REF = '') or (POST <> '') then
          TestREF := False
        else if Advanced then
          TestREF := True
        else
          TestREF := not TestUsdLink(REF);
        if Pos(';2;;', First) <> 0 then
        begin
          NumLinks := Copy(First, 1, Pos(';', First));
          for j := Trunc((NumStr - 2) / 4) downto 1 do
          begin
            UsdUrl := TxtLst.Items[(j * 4) - 2];
            if TestUsdLink(UsdUrl) and TestREF then
            begin
              if TxtLst.IndexOf(UsdUrl) > (j * 4) - 3 then
                UsdLinks := UsdUrl + #13#10 + UsdLinks;
              TxtLst.Delete((j * 4) + 1);
              TxtLst.Delete(j * 4);
              TxtLst.Delete((j * 4) - 1);
              TxtLst.Delete((j * 4) - 2);
            end;
          end;
          StrReplace(First, NumLinks, int2str(Trunc((TxtLst.Count - 2) / 4)) + ';');
          if TxtLst.Count < 3 then
            NotNeedDM := True;
          if UsdLinks <> '' then
          begin
            StrSaveToFile(ReplaceExt(UsdCorr, '.add'), Utf8ToAnsi(UsdLinks));
            CreateProc(UsdCorr + ' /addlinks', SW_SHOW);
          end;
        end
        else
        begin
          NotNeedDM := TestUsdLink(URL) and TestREF;
          if NotNeedDM then
            CreateProc(UsdCorr + ' ' + Utf8ToAnsi(URL), SW_SHOW);
        end;
      end;
      TxtLst.Items[0] := First;
      TxtLst.Items[1] := REF;
      TxtLst.SaveToFile(FgtPath);


      if URL <> '' then
        URL := '"' + Utf8ToAnsi(URL) + '"';
      if REF <> '' then
        REF := '"' + Utf8ToAnsi(REF) + '"';
      if DESC <> '' then
        DESC := '"' + CorrectDesc(Utf8ToAnsi(DESC)) + '"';
      if COOK <> '' then
        COOK := '"' + Utf8ToAnsi(COOK) + '"';
      if POST <> '' then
        POST := '"' + Utf8ToAnsi(POST) + '"';

      //  
      if not NotNeedDM then
        if CustomDMEnabled then
        begin
          ToCustomDM := ReplaceStrToStr(CustomDM, '[url]', URL);
          ToCustomDM := ReplaceStrToStr(ToCustomDM, '[referrer]', REF);
          ToCustomDM := ReplaceStrToStr(ToCustomDM, '[description]', DESC);
          ToCustomDM := ReplaceStrToStr(ToCustomDM, '[cookies]', COOK);
          ToCustomDM := ReplaceStrToStr(ToCustomDM, '[post]', POST);
          CreateProc(CorrectPath(ToCustomDM), SW_SHOW);
        end
        else if DownloadManager <> 'No' then
        begin
          // DM & IDA
          if Advanced and (Pos(';0;;', First) <> 0) and
            (DownloadManager = 'Download Master') or (DownloadManager =
            'Internet Download Accelerator') then
          begin
            if DownloadManager = 'Download Master' then
              Rkey := 'Software\2VG\Download Master'
            else
              Rkey := 'Software\2VG\Internet Download Accelerator';
            kDM := RegKeyOpenRead(HKEY_CURRENT_USER, Rkey);
            PathDM := RegKeyGetStr(kDM, 'ExeFile');
            RegKeyClose(kDM);
          end;

          if (PathDM <> '') and FileExists(PathDM) then
            CreateProc(PathDM + ' ' + URL + ' ' + REF + ' description=' + DESC +
              ' post=' + POST + ' cookies=' + COOK, SW_SHOW)
          else
            ExecuteWait('"' + StartDir + 'FlashGot.exe"', '"' + FgtPath +
              '"', StartDir, SW_HIDE, 100000, nil);
        end;
    end;
    // 
    TxtLst.Free;
    if FileExists(FgtPath) then
      DeleteFile(PChar(FgtPath));
    if FileExists(FgtPath + '.done') then
      DeleteFile(PChar(FgtPath + '.done'));
    AppletTerminated := True;
  end
  else
  begin
    if not JustOne(Form, 'JustOne_oGet') then
      Halt;
    //  Form.Style := Form.Style And Not (WS_THICKFRAME Or WS_MAXIMIZEBOX);
    //  Form.ExStyle := WS_EX_TOOLWINDOW;
    Form.Visible := True;
    Form.StayOnTop := True;
    //  If FileExists(StartDir+'oGet.js') And FileExists(StartDir+'allow-ini-variables.js') Then
    //    begin
    //    DeleteFile(PChar(StartDir+'oGet.js'));
    //    DeleteFile(PChar(StartDir+'allow-ini-variables.js'));
    //    FullInst(tsChecked);
    //    end;
    if Advanced and NeedSearchDM then
      UpdatePanel;
    if UsdExist then
      CheckBox2.Checked := True;
    if CustomDMEnabled then
      CheckBox3.Checked := True;
  end;

end;


procedure TForm1.KOLForm1BeforeCreateWindow(Sender: PObj);
begin
  Form.Font.FontHeight := 13;
end;

procedure TForm1.RadioBox1Show(Sender: PObj);
begin
  if TKOLRadioBox(Sender).Caption = DownloadManager then
    TKOLRadioBox(Sender).SetRadioChecked;
  if Pos(TKOLRadioBox(Sender).Caption + ';', AllDM) = 0 then
    TKOLRadioBox(Sender).Enabled := False
  else
    TKOLRadioBox(Sender).Enabled := True;
end;

procedure TForm1.Button1Show(Sender: PObj);
begin
  Button1.Focused := True;
end;

procedure TForm1.Button3Click(Sender: PObj);
begin
  EditBox1.Visible := False;
  Label1.Visible := True;
  UpdatePanel;
  if UsdExist then
    SearchUsdServers;
end;


procedure TForm1.CheckBox1Click(Sender: PObj);
begin
  SetCheckBox1(CheckBox1.Check3);
  FullInst(CheckBox1.Check3);
  Button1.Focused := True;
end;

procedure TForm1.CheckBox2Click(Sender: PObj);
var
  OSD: POpenSaveDialog;
begin
  if CheckBox2.Checked then
  begin
    OSD := NewOpenSaveDialog('', ExtractFilePath(CorrectPath(USD)),
      DefOpenSaveDlgOptions);
    OSD.Filter := 'Program files|*.exe';
    OSD.Filename := 'USDownloader.exe';
    OSD.WndOwner := Form.Handle;
    OSD.OpenDialog := True;
    if OSD.Execute then
    begin
      USD := OSD.Filename;
      UsdExist := True;
      SearchUsdServers;
    end
    else if not UsdExist then
      CheckBox2.Checked := False;
    OSD.Free;
  end
  else
  begin
    USD := '';
    UsdExist := False;
  end;
  Button1.Focused := True;
end;


procedure TForm1.CheckBox3Click(Sender: PObj);
var
  c: POpenSaveDialog;
  i: integer;
begin
  if CheckBox3.Checked then
  begin
    Label1.Visible := False;
    EditBox1.Visible := True;
    if EditBox1.Text = '' then
    begin
      c := NewOpenSaveDialog('', ExtractOnlyFilePath(CorrectPath(CustomDM)),
        DefOpenSaveDlgOptions);
      c.Filter := 'Program files|*.exe';
      c.WndOwner := Form.Handle;
      c.OpenDialog := True;
      if c.Execute then
      begin
        CustomDM := c.Filename + ' [url]';
        EditBox1.Text := CustomDM;
        CheckBox3.Checked := True;
      end
      else
        CheckBox3.Checked := False;
      c.Free;
      EditBox1.Focused  := True;
      EditBox1.SelStart := EditBox1.TextSize;
    end
    else
      Button1.Focused := True;
    DownloadManager := 'No';
    for i := 0 to Form1.Panel1.ChildCount - 1 do
      Form1.Panel1.Children[i].Checked := False;
  end
  else
  begin
    EditBox1.Visible := False;
    Label1.Visible  := True;
    Button1.Focused := True;
  end;
end;


procedure TForm1.EditBox1Show(Sender: PObj);
begin
  EditBox1.Text := CustomDM;
  EditBox1.SelStart := EditBox1.TextSize;
end;

procedure TForm1.EditBox1Change(Sender: PObj);
begin
  if EditBox1.Text = '' then
  begin
    CheckBox3.Checked := False;
    CustomDM := '';
    Label1.Text := Custom;
  end
  else
  begin
    CheckBox3.Checked := True;
    CustomDM := EditBox1.Text;
    Label1.Text := Capitalize(ExtractFileNameWithoutExt(EditBox1.Text));
  end;
end;

procedure TForm1.Label1Click(Sender: PObj);
begin
  Label1.Visible := False;
  EditBox1.Visible := True;
  CheckBox3.Checked := True;
  CheckBox3Click(Sender);
end;

procedure TForm1.Panel1Click(Sender: PObj);
begin
  if EditBox1.Visible then
  begin
    EditBox1.Visible := False;
    Label1.Visible := True;
  end;
end;

procedure TForm1.Panel2Click(Sender: PObj);
begin
  if EditBox1.Visible then
  begin
    EditBox1.Visible := False;
    Label1.Visible := True;
  end;
end;

end.
